---
image: registry.gitlab.com/yakshaving.art/dockerfiles/go-builder:0.0.1
stages:
  - build
  - docker_image
  - release

build-binary:
  stage: build
  coverage: '/^total:\s+\(statements\)\s+(\d+.\d+)%$/'
  artifacts:
    paths:
    - mqil
  cache:
    paths:
      - .cache
  script:
    - mkdir -p .cache
    - export GOPATH="$CI_PROJECT_DIR/.cache"
    - go mod download
    - make test build

.build-image: &build-image
  image: docker:stable
  stage: release
  services:
    - docker:dind
  variables:
    CONTAINER_IMAGE: registry.gitlab.com/$CI_PROJECT_PATH
    DOCKER_HOST: tcp://docker:2375
    DOCKER_DRIVER: overlay2
  before_script:
    - echo $CI_JOB_TOKEN | docker login -u gitlab-ci-token --password-stdin registry.gitlab.com
  after_script:
    - docker logout

build_docker:
  <<: *build-image
  script:
    - ln -s Dockerfile.amd64 Dockerfile
    - docker build --cache-from ${CONTAINER_IMAGE}:latest
      --tag ${CONTAINER_IMAGE}:${CI_COMMIT_SHA}
      --tag ${CONTAINER_IMAGE}:latest .
  except:
  - master

build_docker_ci:
  <<: *build-image
  script:
    - ln -s Dockerfile-CI.amd64 Dockerfile
    - docker build --cache-from ${CONTAINER_IMAGE}:latest
      --tag ${CONTAINER_IMAGE}:${CI_COMMIT_SHA}-CI
      --tag ${CONTAINER_IMAGE}:latest-ci .
  except:
  - master

release_latest:
  <<: *build-image
  script:
    - ln -s Dockerfile.amd64 Dockerfile
    - docker build --cache-from ${CONTAINER_IMAGE}:latest
      --tag ${CONTAINER_IMAGE}:${CI_COMMIT_SHA}
      --tag ${CONTAINER_IMAGE}:latest .
    - docker push ${CONTAINER_IMAGE}:${CI_COMMIT_SHA}
    - docker push ${CONTAINER_IMAGE}:latest
  only:
  - master

release_latest_ci:
  <<: *build-image
  script:
    - ln -s Dockerfile-CI.amd64 Dockerfile
    - docker build --cache-from ${CONTAINER_IMAGE}:latest-ci
      --tag ${CONTAINER_IMAGE}:${CI_COMMIT_SHA}-CI
      --tag ${CONTAINER_IMAGE}:latest-ci .
    - docker push ${CONTAINER_IMAGE}:${CI_COMMIT_SHA}-CI
    - docker push ${CONTAINER_IMAGE}:latest-ci
  only:
  - master

release_tag:
  <<: *build-image
  script:
    - ln -s Dockerfile.amd64 Dockerfile
    - docker build --cache-from ${CONTAINER_IMAGE}:latest
      --tag ${CONTAINER_IMAGE}:${CI_COMMIT_TAG} .
    - docker push ${CONTAINER_IMAGE}:${CI_COMMIT_TAG}
  only:
  - tags

release_tag_ci:
  <<: *build-image
  script:
    - ln -s Dockerfile-CI.amd64 Dockerfile
    - docker build --cache-from ${CONTAINER_IMAGE}:latest-ci
      --tag ${CONTAINER_IMAGE}:${CI_COMMIT_TAG}-CI .
    - docker push ${CONTAINER_IMAGE}:${CI_COMMIT_TAG}-CI
  only:
  - tags
